/*
 * Viewport.h
 *
 *  Created on: Feb 19, 2009
 *      Author: njoubert
 */

#ifndef VIEWPORT_H_
#define VIEWPORT_H_

#include "global.h"

/**
 * Viewport holds all the information about our camera.
 * This includes how to sample across the viewport. This code should not
 * need to change.
 */
class Viewport {
public:
    Viewport(vec4 eye, vec4 LL, vec4 UL, vec4 LR, vec4 UR, int width, int height);
    virtual ~Viewport();

    /**
     * This will reset the sampler back to its initial state.
     */
    void resetSampler();
    /**
     * This will get the next sample of the viewport.
     * It will fill in the (i,j), (u,v) and (x,y,z) coordinates of p
     * */
    bool getSample(Point & p);

    int getW();
    int getH();

private:
    vec4 _eye;
    vec4 _LL;
    vec4 _UL;
    vec4 _LR;
    vec4 _UR;

    int _pixelsWide;
    int _pixelsHigh;
    int _i;
    int _j;

};

#endif /* VIEWPORT_H_ */
